#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <malloc.h>
#include "stgdk_wc.h"
#include "defs.h"
#include "graphics.h"
#include "keys.h"
#include "map.h"
#include "particle.h"
#include "unitcon.h"
#include "units.h"
#include "screen.h"
#include "subs.h"
#include "weapcon.h"
#include "weapons.h"
#include "radar.h"
#include "text.h"
#include "timer.h"
#include "darksky.h"

unsigned char virtscr[64000];

Unit *NewPlayer(int ship)
{
  UnitData info;
  Unit *temp;
  
  info.pos.x = (rand() % (world.xmax() - 200)) + 100;
  info.pos.y = (rand() % (world.ymax() - 200)) + 100;
  info.angle = rand() % 360;
  info.speed = 0;
  info.team  = T_PLAYER;
  switch (ship)
  {
    case 0: 
      temp = new lPlayer1(info);
      break;
    case 1: 
      temp = new lPlayer2(info);
      break;
    case 2: 
      temp = new lPlayer3(info);
      break;
    case 3: 
      temp = new lPlayer4(info);
      break;
    case 4: 
      temp = new lPlayer5(info);
      break;
    case 5: 
      temp = new lPlayer6(info);
      break;
    case 6: 
      temp = new lPlayer7(info);
      break;
    case 7: 
      temp = new lPlayer8(info);
      break;
  }
  CheckPtr(temp);
  units.Add(temp);
  return temp;
}

Unit *NewCPlayer(int ship, int team)
{
  UnitData info;
  Unit *temp;
  
  info.pos.x = (rand() % (world.xmax() - 200)) + 100;
  info.pos.y = (rand() % (world.ymax() - 200)) + 100;
  info.angle = rand() % 360;
  info.speed = 0;
  info.team  = team;
  switch (ship)
  {
    case 0: 
      temp = new cPlayer1(info);
      break;
    case 1: 
      temp = new cPlayer2(info);
      break;
    case 2: 
      temp = new cPlayer3(info);
      break;
    case 3: 
      temp = new cPlayer4(info);
      break;
    case 4: 
      temp = new cPlayer5(info);
      break;
    case 5: 
      temp = new cPlayer6(info);
      break;
    case 6: 
      temp = new cPlayer7(info);
      break;
    case 7: 
      temp = new cPlayer8(info);
      break;
  }
  CheckPtr(temp);
  units.Add(temp);
  
  return temp;
}

char *PlayerSetup(int &ship)
/*
  This function is a modification of the original pickship().
  'which' determines if the user is entering a name or picking a ship.
  0 == entering a name, 1 == picking a ship
  FIXME:  A 125 line function?  Well, it works...
*/
{
  char    name[32],
          temp[32],
          typed[2];
  int     angle[8],
          x,
          pos,
          which,
          flash,
          enter;
  sprites ships[8];

  ships[0] = getspr("ship1.spr");
  ships[1] = getspr("ship2.spr");
  ships[2] = getspr("ship3.spr");
  ships[3] = getspr("ship4.spr");
  ships[4] = getspr("ship5.spr");
  ships[5] = getspr("ship6.spr");
  ships[6] = getspr("ship7.spr");
  ships[7] = getspr("ship8.spr");

  for(x = 0; x < 8; x++)
    angle[x] = 0;
  ship = 3;
  which = 0;
  strcpy(name, "player");
  pos = strlen(name) + 1;
  strcpy(typed, " ");
  enter = FALSE;

  keyb.ClearKeys();
  while ((enter == FALSE) || (which == 0))
  {
    keyb.ClearKeys();
    vclear();

    if (which == 0)
    {
      typed[0] = keyb.GChar();
      if ((typed[0] != 0) && (pos < 17))
      {
        strcat(name, typed);
        pos++;
      }
      if ((keyb.Pressed(kBACKSPACE)) && (pos > 1))
      {
        name[pos - 2] = 0;
        pos--;
      }
      flash++;
      if ((pos < 17) && (flash % 2 == 0))
        typed[0] = 128;                       // assign the cursor char
      else
        typed[0] = ' ';                       // assign a space
      strcpy(temp, name);                   // copy for printing
      strcat(temp, typed);                  // add the cursor char
      x = text.OutC(160, 43, 48, temp);
      setcolor(27);
      rect(158 - (x / 2), 40, 162 + (x / 2), 50);
      if ((keyb.Hit(kUP)) || (keyb.Hit(kDOWN)) || (enter == TRUE))
        which = 1;
    }      
    else
    {
      if (keyb.Hit(kRIGHT))
      {
        ship++;
        if (ship > 7)
          ship = 0;
      }
      if (keyb.Hit(kLEFT))
      {
        ship--;
        if (ship < 0)
          ship = 7;
      }
      
      x = text.OutC(160, 43, 48, name);
      setcolor(38);
      rect(158 - (x / 2), 40, 162 + (x / 2), 50);
      
      angle[ship] += 5;
      FixAngle(angle[ship]);
      
      if ((keyb.Hit(kUP)) || (keyb.Hit(kDOWN)))
        which = 0;
    }
  
    for(x = 0; x < 8; x++)
    {
      if ((x == ship) && (which == 1))  // highlite selected if picking ship
        setcolor(27);
      else
        setcolor(38);
      rect((x * 40), 85, (x * 40) + 35, 115);
      angleput((x * 40) + 18, 100, angle[x], ships[x][0], virtscr);
    }
      
    text.Out(134, 70, 48, "select a ship:");

    text.OutC(40, 120, 48, "klingons");
    text.OutC(120, 120, 48, "humans");
    text.OutC(200, 120, 48, "romulans");
    text.OutC(280, 120, 48, "ferrengi");
    
    vretrace();
    memcpy(BASESCREEN, virtscr, 64000);
    enter = keyb.Hit(kENTER);
  }
  return name;
}

int DoMenu(Menu menu, int &curr)
{
  // red = 27, blue = 38
  const int  TEXTHGT = 10;
        int  i,
             row,
             start,
             first;
  
  start = 100 - ((menu.items / 2) * TEXTHGT);
  first = TRUE;

  for(;;)                   // nice use of an empty for
  {
    vclear();
    row = start;
    for(i = 0; i < menu.items; i++)
    {
      if (i == curr)
        text.OutC(160, row, 27, menu.text[i]);
      else
        text.OutC(160, row, 38, menu.text[i]);
      row += TEXTHGT;
    }
    keyb.ClearKeys();
    if (keyb.Hit(kENTER))
    {
      return curr;
    }
    if (first == TRUE)
      first = FALSE;
    else
      while (!keyb.Hit());
    if (keyb.Hit(kESC))
      return -1;
    if (keyb.Hit(kUP))
    {
      curr--;
      if (curr < 0)
        curr = menu.items - 1;
    }
    if (keyb.Hit(kDOWN))
    {
      curr++;
      if (curr == menu.items)
        curr = 0;
    }
    vretrace();
    memcpy(BASESCREEN, virtscr, 64000);
  }
}

//===========================================================================

void UpdateLocal(int num)
{
  static Unit *players[TEAMS];
  static  int ships[TEAMS],
              bots;
          int x;

  if (num != 0)                             // is it the first time through?
  {
    bots = num;
    for(x = 1; x <= bots; x++)
    {
      ships[x] = rand() % 8;
      players[x] = NewCPlayer(ships[x], x);
    }
  }
  else
  {
    for(x = 1; x <= bots; x++)               // respawn all computers
      if (units.Exist(players[x]) == FALSE)
        players[x] = NewCPlayer(ships[x], x);
  }
}

void UpdateGame(int gametype)
{
  static int game;

  if (gametype != -1)
    game = gametype;
  else
  {
    switch(game)
    {
      /*
      case 0:               // single
        UpdateSingle(0);
        break;
      */
      case 1:               // local
        UpdateLocal(0);
        break;
      /*
      case 2:               // serial
        UpdateSerial(0);
        break;
      case 3:               // ipx network  
        UpdateIPX(0);
        break;
      */
    }
  }
}

void CleanUp()
{
  units.Kill();
  weapons.Kill();
  part.Kill();
  text.Kill();
}

void PlayGame(int ship)
{
  Unit  *player;
  
  player = NewPlayer(ship);       // give the player a ship to start with

  TimerOn();
  
  keyb.ClearKeys();
  while (keyb.Pressed(kESC) == FALSE)
  {
    keyb.ClearKeys();
      
    if (keyb.Hit(kTILDE))
      text.Print(TimerFPS());

    if ((units.Exist(player) == FALSE))     // if the player is dead
      if (keyb.Hit(kSPACE))                 // and they want to respawn,
        player = NewPlayer(ship);           // respawn them

    while(keyb.Pressed(kBACKSLASH));

    vclear();

    part.Update();
    units.Update();
    text.Update();

    UpdateGame(-1);
    
    world.Draw();
    part.Draw();
    weapons.Draw();
    units.Draw();
    
    if (units.Exist(player) == TRUE)
      Radar(player);
    text.Draw();

    vretrace();
    memcpy(BASESCREEN, virtscr, 64000);
  
    TimerUpdate();
  }
  
  TimerOff();
  
  if (units.Exist(player) == TRUE)              // kill player (for multi)
    player->Damage(50000, player, player->team());
  CleanUp();
}

void Local()
{
  int ship,
      i,
      menu;
  
  UpdateGame(1);
  
  menu = 1;
  do 
    i = DoMenu(LOCAL_MENU, menu);
  while (i < 1);

  for(menu = 1; menu <= i; menu++)
  {
    teams[menu].kills = 0;
    strcpy(teams[menu].name, COMPNAME[menu - 1]);
  }
  UpdateLocal(i);

  numteams = i;
  
  teams[0].kills = 0;                         // team 0 is local player
  strcpy(teams[0].name, PlayerSetup(ship));   // in a local game (huh?)
  
  PlayGame(ship);
}

void GameMulti()
{
  int multi;

  multi = 0;
  for(;;)
    switch(DoMenu(MULTI_MENU, multi))
    {
      case -1:
        return;
      case 0:
        Local();
        return;
    }
}

void Game()
{
  int menu;
      
  menu = 0;
  for(;;)
    switch (DoMenu(MAIN_MENU, menu))
    {
      case 1:
        GameMulti();
        break;
      case 4:
        return;
    }
}

int main()      // int argc, const char *argv[]
{
  maketables();
  randomize();
  
  world.Load("game.map", "game.spr");

  InitScreen("game.pal", FALSE);
  setvaddr(virtscr);
  setvport(0, 0, 319, 199);
  clipping = TRUE;
  
  TimerInit(30);          // max FPS
  
  Game();

  TimerFree();
  
  RestoreScreen();

//  TimerPrint();
  return 0;
}
