//  uses Stellar Game Development Kit key handler

#include <iostream.h>
#include "stgdk_wc.h"
#include "keys.h"

Keys::Keys()
{
  // install key handler
  install_keybhandler();
}

Keys::~Keys()
{
  // uninstall key handler
  uninstall_keybhandler();
}

int Keys::Hit()
{
  return keybhit();
}

int Keys::Hit(int key)
{
  // is it pressed and not been checked before?
  if ((pressed(key) == TRUE) && (hit[key] == FALSE))
  {
    // mark it
    hit[key] = TRUE;
    return(TRUE);
  }
  else
    return(FALSE);
}

int Keys::Pressed(int key)
{
  // is it pressed?
  if (pressed(key) == TRUE)
    return TRUE;
  else
    return FALSE;
}

void Keys::ClearKeys()
{
  int key;

  // run through all keys
  for(key = 0; key < 128; key++)
  {
    // is it not pressed?  then clear it
    if (pressed(key) == FALSE)
      hit[key] = FALSE;
  }
}

char Keys::GChar()
/*
  This may or not be the most efficient way to program this.
  It was programmed this way more for readability than speed.
  Easy to modify, and the compiler should do a good job with this.
  The mess below is why the BIOS was written...
*/
{
  if (Hit(kSPACE))
    return ' ';
  if ((Pressed(kLEFTSHIFT)) || (Pressed(kRIGHTSHIFT)))
  {
    if (Hit(kA))
      return 'A';
    if (Hit(kB))
      return 'B';
    if (Hit(kC))
      return 'C';
    if (Hit(kD))
      return 'D';
    if (Hit(kE))
      return 'E';
    if (Hit(kF))
      return 'F';
    if (Hit(kG))
      return 'G';
    if (Hit(kH))
      return 'H';
    if (Hit(kI))
      return 'I';
    if (Hit(kJ))
      return 'J';
    if (Hit(kK))
      return 'K';
    if (Hit(kL))
      return 'L';
    if (Hit(kM))
      return 'M';
    if (Hit(kN))
      return 'N';
    if (Hit(kO))
      return 'O';
    if (Hit(kP))
      return 'P';
    if (Hit(kQ))
      return 'Q';
    if (Hit(kR))
      return 'R';
    if (Hit(kS))
      return 'S';
    if (Hit(kT))
      return 'T';
    if (Hit(kU))
      return 'U';
    if (Hit(kV))
      return 'V';
    if (Hit(kW))
      return 'W';
    if (Hit(kX))
      return 'X';
    if (Hit(kY))
      return 'Y';
    if (Hit(kZ))
      return 'Z';
    if (Hit(kTILDE))
      return '~';
    if (Hit(k1))
      return '!';
    if (Hit(k2))
      return '@';
    if (Hit(k3))
      return '#';
    if (Hit(k4))
      return '$';
    if (Hit(k5))
      return '%';
    if (Hit(k6))
      return '^';
    if (Hit(k7))
      return '&';
    if (Hit(k8))
      return '*';
    if (Hit(k9))
      return '(';
    if (Hit(k0))
      return ')';
    if (Hit(kMINUS))
      return '_';
    if (Hit(kPLUS))
      return '+';
    if (Hit(kOPENSQUARE))
      return '{';
    if (Hit(kCLOSESQUARE))
      return '}';
    if (Hit(kBACKSLASH))
      return '|';
    if (Hit(kSEMICOLON))
      return ':';
    if (Hit(kAPOSTROPHE))     // using the actual chars gets weird
      return '"';
    if (Hit(kCOMMA))
      return '<';
    if (Hit(kPERIOD))
      return '>';
    if (Hit(kFORWARDSLASH))
      return '?';
  }
  else
  {
    if (Hit(kA))
      return 'a';
    if (Hit(kB))
      return 'b';
    if (Hit(kC))
      return 'c';
    if (Hit(kD))
      return 'd';
    if (Hit(kE))
      return 'e';
    if (Hit(kF))
      return 'f';
    if (Hit(kG))
      return 'g';
    if (Hit(kH))
      return 'h';
    if (Hit(kI))
      return 'i';
    if (Hit(kJ))
      return 'j';
    if (Hit(kK))
      return 'k';
    if (Hit(kL))
      return 'l';
    if (Hit(kM))
      return 'm';
    if (Hit(kN))
      return 'n';
    if (Hit(kO))
      return 'o';
    if (Hit(kP))
      return 'p';
    if (Hit(kQ))
      return 'q';
    if (Hit(kR))
      return 'r';
    if (Hit(kS))
      return 's';
    if (Hit(kT))
      return 't';
    if (Hit(kU))
      return 'u';
    if (Hit(kV))
      return 'v';
    if (Hit(kW))
      return 'w';
    if (Hit(kX))
      return 'x';
    if (Hit(kY))
      return 'y';
    if (Hit(kZ))
      return 'z';
    if (Hit(kTILDE))
      return '`';
    if (Hit(k1))
      return '1';
    if (Hit(k2))
      return '2';
    if (Hit(k3))
      return '3';
    if (Hit(k4))
      return '4';
    if (Hit(k5))
      return '5';
    if (Hit(k6))
      return '6';
    if (Hit(k7))
      return '7';
    if (Hit(k8))
      return '8';
    if (Hit(k9))
      return '9';
    if (Hit(k0))
      return '0';
    if (Hit(kMINUS))
      return '-';
    if (Hit(kPLUS))
      return '=';
    if (Hit(kOPENSQUARE))
      return '[';
    if (Hit(kCLOSESQUARE))
      return ']';
    if (Hit(kBACKSLASH))
      return '\\';
    if (Hit(kSEMICOLON))
      return ';';
    if (Hit(kAPOSTROPHE))     // using the actual chars gets weird
      return '\'';
    if (Hit(kCOMMA))
      return ',';
    if (Hit(kPERIOD))
      return '.';
    if (Hit(kFORWARDSLASH))
      return '/';
  }
  return 0;
}

Keys keyb;    // keyb is used to get all input from the keyboard
