//===========================================================================
cPlayer1::cPlayer1(UnitData &info):
Unit(info, "ship1.spr")
{
  data.shields = SHIP1_SHIELDS;
  data.hull = SHIP1_HULL;
  data.collision = 25;
  data.classname =  C_SHIP1C;
  ai.target = NULL;
}

///////////////
void cPlayer1::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer1::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer1::TakeDamage() {}

