#ifndef __particle_h
#define __particle_h

typedef struct
{
  point pos;      // location in world
    int angle,    // angle in degrees (only used with speed)
        speed,    // speed in pixels/frame
        life,     // time until particle expires (0 == expired)
        color,    // color
        decay;    // value to increment color by each frame
} ParticleData;

class Particle
{
  public:
    Particle(ParticleData &info);
    ~Particle() {};
    int Update();
    void Draw();

  protected:
    ParticleData data;
};

class Particles
{
  public:
    Particles() { last = 0; }
    ~Particles() {};
    void Add(ParticleData &init);
    int Update();
    void Draw();
    void Kill();

  protected:
    Particle *heap[16384];
    int      last;
};

extern Particles part;

#endif
