#include <stdio.h>
#include <stdlib.h>
#include "stgdk_wc.h"
#include "defs.h"
#include "unitcon.h"
#include "map.h"
#include "keys.h"

void Radar(Unit *unit)
{
  // colors: red, blue, green, orange, yellow, brown, purple, magenta
  const  byte  colors[] = {27, 38, 48, 56, 70, 83, 91, 251},
               RXSIZE = 32,
               RYSIZE = 32,
               XSCALE = 20,
               YSCALE = 20;
  static int   xdiv   = ((world.xmax() / RXSIZE) + 0.5),
               ydiv   = ((world.ymax() / RYSIZE) + 0.5),
               xmul   = RXSIZE * XSCALE,
               ymul   = RYSIZE * YSCALE,
               xscl   = XSCALE * 2,
               yscl   = YSCALE * 2,
               hrxs   = ((RXSIZE / 2) + 0.5),
               hrys   = ((RYSIZE / 2) + 0.5),
               display = 1,
               showscore = 0,
               scoretime = 0;
         Unit  *temp;
         point pos,
               ppos;
         int   x, 
               y;

         char    message[255];
         paltype pal[256];
  static sprites font = loadspr("text.spr", pal);
  
  if (keyb.Hit(kR))
  {
    if (display == 0)
      display = 1;
    else
      display = 0;
  }
  
  setcolor(255);
  rect(0, 0, RXSIZE + 1, RYSIZE + 1);
  rect(318 - RXSIZE, 0, 319, RYSIZE + 1);
  setcolor(0);
  frect(1, 1, RXSIZE, RYSIZE);
  frect(319 - RXSIZE, 1, 318, RYSIZE);

  ppos = unit->pos();
  temp = units.ChainAll();
  while (temp != NULL)
  {
    pos = temp->pos();    
    
    if (display == 0)
      ppix((pos.x / xdiv) + 1.5, (pos.y / ydiv) + 1.5, colors[temp->team() % 8]);
    else
    {
      if (temp == unit)
        ppix((pos.x / xdiv) + 1.5, (pos.y / ydiv) + 1.5, colors[0]);
      else
        ppix((pos.x / xdiv) + 1.5, (pos.y / ydiv) + 1.5, colors[1]);
    }
    
    x = pos.x - ppos.x;
    y = pos.y - ppos.y;
    if (display == 0)
    {
      if ((temp != unit) && (abs(x) < xmul) && (abs(y) < ymul))
        ppix((x / xscl) + hrxs + (319 - RXSIZE), 
              (y / yscl) + hrys, colors[temp->team() % 8]);
      else
        ppix(319 - hrxs, hrys, colors[unit->team() % 8]);
    }
    else
    {
      if ((temp != unit) && (abs(x) < xmul) && (abs(y) < ymul))
        ppix((x / xscl) + hrxs + (319 - RXSIZE), 
              (y / yscl) + hrys, colors[1]);
      else
        ppix(319 - hrxs, hrys, colors[0]);
    }
    temp = units.ChainNext();
  }

  if (unit->Fire() == TRUE)
    sprintf(message, "shields: %i    hull: %i    weapons ready", 
            unit->shields(), unit->hull());
  else
    sprintf(message, "shields: %i    hull: %i    charging...%i",
            unit->shields(), unit->hull(), unit->Fire());
  outfontmono(font, 72, 4, 47, message);
  sprintf(message, "               kills: %i                ",
          teams[unit->team()]);
  outfontmono(font, 72, 12, 46, message);

  scoretime--;
  if (keyb.Hit(kENTER))
    scoretime = 40;
  if (keyb.Hit(kS))
  {
    if ((showscore == 1) || (scoretime > 0))
    {
      showscore = 0;
      scoretime = 0;
    }
    else
      showscore = 1;
  }
  if ((showscore == 1) || (scoretime > 0))
    for(x = 0; x <= numteams; x++)
    {
      sprintf(message, "%16s", teams[x].name);
      outfontmono(font, 75, 25 + (x * 9), 44, message);
      sprintf(message, "%i", teams[x].kills);
      outfontmono(font, 185, 25 + (x * 9), 45, message);
    }
}
