#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "stgdk_wc.h"
#include "screen.h"

char    *TextMem;
int     CursorX, 
        CursorY;
paltype OldPal[256];


///////////////////////////////////////////////////////////////////////////////
void InitScreen (char *fname, char fade)
{
  paltype pal[256];
  
  // save the old palette, load in the game one
  getpal(OldPal);
  loadpal(fname, pal);

  // print out our little copyright message
  printf("***** Copyright (c) David Phillips, 1998 *****\n");
  
  // save the cursor position and the screen
  CursorX = wc_wherex(0);
  CursorY = wc_wherey(0);
  TextMem = malloc(80 * 25 * 2);
  if (TextMem == NULL)
  {
    printf("InitScreen:   Failed on allocation of 2000 bytes!\n");
    exit(1);
  }
  memcpy(TextMem, TEXTMEMORY, (80 * 25 * 2));
  
  // if they want to fade out, decrease palette to 0, delaying 15ms
  if (fade == TRUE)
    fadeout(15, 0, 255);
  
  // set the video mode to 13h, VGA 320x200 256 colors
  setvmode(vm_320x200);
  
  // set the game palette
  setpal(pal, 0, 255);
}

///////////////////////////////////////////////////////////////////////////////
void RestoreScreen (void)
{
  // set the video mode to 03h, TEXT 80x25 16 colors
  setvmode(vm_80x25);
  
  // restore the old palette, screen, cursor position, and free the memory
  setpal(OldPal, 0, 255);
  memcpy(TEXTMEMORY, TextMem, (80 * 25 * 2));
  wc_gotoxy(CursorX, CursorY + 1, 0);
  free(TextMem);
}
