#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "stgdk_wc.h"
#include "graphics.h"
#include "unitcon.h"
#include "subs.h"

///////////////////////////////////////////////////////////////////////////////
void CheckPtr(void *pointer)
{
  // is the pointer null?
  if (pointer == NULL)
  {
    // restore the screen to text mode and quit with an error message
    setvmode(vm_80x25);
    cout << "CheckPtr: Allocation of memory failed!\n";
    exit(1);
  }
}

///////////////////////////////////////////////////////////////////////////////
void randomize ()
{
  // generate a random number for rand() by hashing up the
  // current clock ticks and the interrupt table
  // idea taken from id software's SERSETUP
  int num;
  ptr intr;
    
  num = clock();
  for (intr = (ptr)0x0; intr < (ptr)0x1024; intr++)
    num += *intr;
  srand(num);
}

///////////////////////////////////////////////////////////////////////////////
int xAdj(int angle, int speed)
{
  int adj = 0;
  
  FixAngle(angle);

  while (speed > 31)
  {
    adj += sinMulL[angle][63];
    speed -= 31;
  }
  adj += sinMulL[angle][speed + 32];

  return adj;
}

///////////////////////////////////////////////////////////////////////////////
int yAdj(int angle, int speed)
{
  int adj = 0;
  
  FixAngle(angle);

  while (speed > 31)
  {
    adj -= cosMulL[angle][63];
    speed -= 31;
  }
  adj -= cosMulL[angle][speed + 32];
  
  return adj;
}

///////////////////////////////////////////////////////////////////////////////
void FixAngle(int &angle)
{
  while (angle < 0)
    angle += 360;
  while (angle >= 360)
    angle -= 360;
}

///////////////////////////////////////////////////////////////////////////////
int Distance(point pos1, point pos2)
{
  return sqrt(pow((pos1.x - pos2.x), 2) + pow((pos1.y - pos2.y), 2));
}

///////////////////////////////////////////////////////////////////////////////
int FindAngle(point pos1, point pos2)
{
  const double RADCONV = 57.295779513082;   // value from TI-86
           int x;
   
   x = ((atan2(pos1.y - pos2.y, pos1.x - pos2.x) * RADCONV) + 0.5) - 90;
   if (x < 0)
    x += 360;

  return x;
}

///////////////////////////////////////////////////////////////////////////////
void MoveAngle(int &current, int ideal, int speed)
{
  // idea taken from id software's Quake C
  int move;
  
  move = ideal - current;
  if (ideal > current)
  {
    if (move > 180)
      move = move - 360;
  }
  else
  {
    if (move < -180)
      move = move + 360;
  }
    
  if (move > 0)
  {
    if (move > speed)
      move = speed;
  }
  else
  {
    if (move < 0 - speed)
      move = 0 - speed;
  }

  current += move;
  FixAngle(current);
}
