#include <string.h>
#include "stgdk_wc.h"
#include "text.h"

Text::Text()
{
  paltype pal[256];
  
  start = 200 - (8 * TEXTLINES);          // FIXME:  hardcoded font size
  col = 0;
  next = TEXTFRAMES;
  font = loadspr("text.spr", pal);
}

void Text::Print(char *string)
{
  int x;
  
  if (col == TEXTLINES)                     // are we on the last line?
  {
    for(x = 1; x < TEXTLINES; x++)          // scroll everything up one
      strcpy(data[x - 1], data[x]);
    strcpy(data[TEXTLINES - 1], string);
  }
  else
  {
    strcpy(data[col], string);
    col++;
  }
  
  if (col == 1)                             // are we the only thing?
    next = TEXTFRAMES;                      // reset the timer
}

void Text::Update()
{
  int x;
  
  next--;
  if (next == 0)                            // time to scroll?
  {
    next = TEXTFRAMES;
    col--;
    if (col < 0)                            // can't be that far off screen
      col = 0;
    for(x = 1; x < TEXTLINES; x++)          // just like above
      strcpy(data[x - 1], data[x]);
    strcpy(data[TEXTLINES - 1], "");
  }
}

void Text::Draw()
{
  int x,
      y;
  
  y = start;
  for(x = 0; x < col; x++)
  {
    outfontmono(font, 0, y, 48, data[x]);     // draw to the screen
    y += 8;
  }
}

void Text::Out(int x, int y, int c, char *string)
{
  outfontmono(font, x, y, c, string);     // draw to the screen
}

int Text::OutC(int x, int y, int c, char *string)
{
  int i,
      length;

  for(i = 0, length = 0; string[i] != 0; i++)         // find length
    length += getwid(font[string[i]]);
  outfontmono(font, x - (length / 2), y, c, string);  // draw to the screen
  
  return length;
}

void Text::Kill()
{
  col = 0;
}

///////////////////////////////////////////////////////////////////////////////
Text text;
