#include <stdio.h>
#include <stdlib.h>
#include "stgdk_wc.h"

volatile int ticks;
         int frames,
             last,
             on;

void interrupt timerisr(void)
{
  if (on == TRUE)
    ticks++;
}

void TimerInit(int maxfps)
{
  save_timerint();
  installtimer(timerisr);
  timer_setpollrate(maxfps);

  frames = 0;
  ticks = 0;
  on = FALSE;
}

void TimerUpdate(void)
{
  frames++;
  
  while (ticks == last) {};               // lock frames to max fps
  last = ticks;
}

void TimerFree(void)
{
  restore_timerint();
}

void TimerOn(void)
{
  on = TRUE;
}

void TimerOff(void)
{
  on = FALSE;
}

void TimerPrint(void)
{
  printf("\nFrames: %i\n", frames);
  printf("Timer ticks: %i\n", ticks);
  printf("FPS: %3.2f\n", fps(ticks, frames));
}

char *TimerFPS(void)
{
  char *message;
  
  message = (char *)malloc(15);
  sprintf(message, "FPS: %3.2f", fps(ticks, frames));
  return message;
}
