#include <iostream.h>
#include <stdlib.h>
#include "stgdk_wc.h"
#include "defs.h"
#include "unitcon.h"
#include "units.h"
#include "subs.h"
#include "keys.h"
#include "map.h"
#include "weapcon.h"
#include "weapons.h"
#include "particle.h"

//===========================================================================
cPlayer1::cPlayer1(UnitData &info):
Unit(info, "ship1.spr")
{
  data.shields = SHIP1_SHIELDS;
  data.hull = SHIP1_HULL;
  data.collision = data.hull;
  data.classname =  C_SHIP1C;
  ai.target = NULL;
}

///////////////
void cPlayer1::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer1::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer1::TakeDamage() {}

//===========================================================================
cPlayer2::cPlayer2(UnitData &info):
Unit(info, "ship2.spr")
{
  data.shields = SHIP2_SHIELDS;
  data.hull = SHIP2_HULL;
  data.collision = data.hull;
  data.classname =  C_SHIP2C;
  ai.target = NULL;
}

///////////////
void cPlayer2::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer2::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer2::TakeDamage() {}

//===========================================================================
cPlayer3::cPlayer3(UnitData &info):
Unit(info, "ship3.spr")
{
  data.shields = SHIP3_SHIELDS;
  data.hull = SHIP3_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP3C;
  ai.target = NULL;
}

///////////////
void cPlayer3::PreThink() 
{
  int dist;
  
  if ((units.Exist(ai.target) == FALSE) ||            // does target exist?
      (Distance(data.pos, ai.target->pos()) > 500))   // too far away?
    ai.target = Closest();                            // new victim

  if (ai.target != NULL)                              // we the only one?
  {
    MoveAngle(data.angle, FindAngle(data.pos, 
               ai.target->pos()), SHIP3_TURNRATE);    // turn towards them
    
    dist = Distance(data.pos, ai.target->pos());      // find our distance
  //if (dist > 150)                                   // real far?
      data.speed = SHIP3_SPEED;                       // max speed
  /*else        
    {
      if (dist > 75)                                  // mid range?
        data.speed = 4;                               // moderate speed
      else
        if (dist > 35)                                // close quarters?
          data.speed = 1;                             // inch up on them
    }*/
  }

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer3::PostThink() 
{
  int dist;
  
  if ((units.Exist(ai.target) == FALSE) ||            // does target exist?
      (Distance(data.pos, ai.target->pos()) > 500))   // too far away?
    ai.target = Closest();                            // new victim

  if (ai.target != NULL)                              // we the only one?
  {
    dist = Distance(data.pos, ai.target->pos());      // find our distance
    if ((dist < 200) && (dist > 100))                  // mid range?
      new MiniMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    else                                              // real close?
      if (dist < 75)
      {
        new MiniLaser(data.pos.x + xAdj(data.angle - 90, 8), data.pos.y + 
                    yAdj(data.angle - 90, 8), data.angle, this, data.team);
        new MiniLaser(data.pos.x + xAdj(data.angle + 90, 8), data.pos.y + 
                    yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
  }
}

///////////////
void cPlayer3::TakeDamage() {}

//===========================================================================
cPlayer4::cPlayer4(UnitData &info):
Unit(info, "ship4.spr")
{
  data.shields = SHIP4_SHIELDS;
  data.hull = SHIP4_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP4C;
  ai.target = NULL;
}

///////////////
void cPlayer4::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer4::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer4::TakeDamage() {}


//===========================================================================
cPlayer5::cPlayer5(UnitData &info):
Unit(info, "ship5.spr")
{
  data.shields = SHIP5_SHIELDS;
  data.hull = SHIP5_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP5C;
  ai.target = NULL;
}

///////////////
void cPlayer5::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer5::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer5::TakeDamage() {}

//===========================================================================
cPlayer6::cPlayer6(UnitData &info):
Unit(info, "ship6.spr")
{
  data.shields = SHIP6_SHIELDS;
  data.hull = SHIP6_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP6C;
  ai.target = NULL;
}

///////////////
void cPlayer6::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer6::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer6::TakeDamage() {}

//===========================================================================
cPlayer7::cPlayer7(UnitData &info):
Unit(info, "ship7.spr")
{
  data.shields = SHIP7_SHIELDS;
  data.hull = SHIP7_HULL;
  data.collision = data.hull;
  data.classname =  C_SHIP7C;
  ai.target = NULL;
}

///////////////
void cPlayer7::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer7::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer7::TakeDamage() {}

//===========================================================================
cPlayer8::cPlayer8(UnitData &info):
Unit(info, "ship8.spr")
{
  data.shields = SHIP8_SHIELDS;
  data.hull = SHIP8_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP8C;
  ai.target = NULL;
}

///////////////
void cPlayer8::PreThink() 
{
  int dist;
    
  if (units.Exist(ai.target) == FALSE)
    ai.target = Closest();
   
  if (ai.target != NULL)
  {
    MoveAngle(data.angle, FindAngle(data.pos, ai.target->pos()), 10);
    
    dist = Distance(data.pos, ai.target->pos());
    if ((dist > 200) || (data.shields < 10))
      data.speed = 8;
    else
    {
      if (dist > 150)
        data.speed = 5;
      else
      {
        if (dist > 100)
          data.speed = 3;
        else
        {
          if (data.speed > 50)
            data.speed = 1;
          else
            data.speed = 0;
        }
      }
    }
  }
  else
    data.speed = 0;

  FixAngle(data.angle);
  data.drawangle = data.angle;
}

///////////////
void cPlayer8::PostThink() 
{
   int dist;
  
  if ((units.Exist(ai.target) == FALSE) || 
      (Distance(data.pos, ai.target->pos()) > 500))
    ai.target = Closest();

  if (ai.target != NULL)
  {
    dist = Distance(data.pos, ai.target->pos());
    if (dist <= 150)
    {
      if (rand() % 10 == 0)
      {
          new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
          new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
      }
      else
      {
          if(rand() % 7 == 0)
              new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
          else
          {
              if(rand() % 9 == 0)
                new DisableCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                  data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
              else
                  if(rand() % 5 == 0)
                    new Mirv(data.pos.x + xAdj(data.angle + 90, 8), 
                        data.pos.y + yAdj(data.angle + 90, 8), 
                        data.angle, this, data.team);
          }
      }
    }
    else
    {
      if (dist <= 200)
        if (rand() % 10 == 0)
          new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
    }
  }
}

///////////////
void cPlayer8::TakeDamage() {}

//===========================================================================
lPlayer1::lPlayer1(UnitData &info):
Unit(info, "ship1.spr") 
{
  data.shields = SHIP1_SHIELDS;
  data.hull = SHIP1_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP1L;
}

///////////////
void lPlayer1::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP1_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP1_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP1_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP1_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP1_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP1_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP1_SPEED)
    data.speed = -SHIP1_SPEED;
  if (data.speed > SHIP1_SPEED)
    data.speed = SHIP1_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer1::PostThink()
{
  if (keyb.Pressed(kCTRL))
    new PlasmaCannon(data.pos.x, data.pos.y, data.angle, this, data.team);
  
  if (keyb.Pressed(kZ))
    new Mirv(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer1::TakeDamage() {}

//===========================================================================
lPlayer2::lPlayer2(UnitData &info):
Unit(info, "ship2.spr") 
{
  data.shields = SHIP2_SHIELDS;
  data.hull = SHIP2_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP2L;
}

///////////////
void lPlayer2::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP2_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP2_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP2_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP2_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP2_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP2_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP2_SPEED)
    data.speed = -SHIP2_SPEED;
  if (data.speed > SHIP2_SPEED)
    data.speed = SHIP2_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer2::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new MiniLaser(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new MiniLaser(data.pos.x, data.pos.y, data.angle, this, data.team);
    new MiniLaser(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new MiniMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer2::TakeDamage() {}

//===========================================================================
lPlayer3::lPlayer3(UnitData &info):
Unit(info, "ship3.spr") 
{
  data.shields = SHIP3_SHIELDS;
  data.hull = SHIP3_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP3L;
}

///////////////
void lPlayer3::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP3_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP3_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP3_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP3_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP3_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP3_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP3_SPEED)
    data.speed = -SHIP3_SPEED;
  if (data.speed > SHIP3_SPEED)
    data.speed = SHIP3_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer3::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new MiniLaser(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new MiniLaser(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new MiniMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer3::TakeDamage() {}

//===========================================================================
lPlayer4::lPlayer4(UnitData &info):
Unit(info, "ship4.spr") 
{
  data.shields = SHIP4_SHIELDS;
  data.hull = SHIP4_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP4L;
}

///////////////
void lPlayer4::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP4_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP4_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP4_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP4_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP4_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP4_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP4_SPEED)
    data.speed = -SHIP4_SPEED;
  if (data.speed > SHIP4_SPEED)
    data.speed = SHIP4_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer4::PostThink()
{
  if (keyb.Pressed(kCTRL))
    new LaserCannon(data.pos.x, data.pos.y, data.angle, this, data.team);

  if (keyb.Pressed(kZ))
    new DumbFireMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer4::TakeDamage() {}

//===========================================================================
lPlayer5::lPlayer5(UnitData &info):
Unit(info, "ship5.spr") 
{
  data.shields = SHIP5_SHIELDS;
  data.hull = SHIP5_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP5L;
}

///////////////
void lPlayer5::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP5_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP5_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP5_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP5_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP5_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP5_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP5_SPEED)
    data.speed = -SHIP5_SPEED;
  if (data.speed > SHIP5_SPEED)
    data.speed = SHIP5_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  if(keyb.Pressed(kEND)) data.speed = 100;

  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer5::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new PlasmaCannon(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new PlasmaCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new DisableCannon(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer5::TakeDamage() {}

//===========================================================================
lPlayer6::lPlayer6(UnitData &info):
Unit(info, "ship6.spr") 
{
  data.shields = SHIP6_SHIELDS;
  data.hull = SHIP6_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP6L;
}

///////////////
void lPlayer6::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP6_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP6_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP6_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP6_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP6_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP6_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP6_SPEED)
    data.speed = -SHIP6_SPEED;
  if (data.speed > SHIP6_SPEED)
    data.speed = SHIP6_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer6::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new BlastBeam(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer6::TakeDamage() {}

//===========================================================================
lPlayer7::lPlayer7(UnitData &info):
Unit(info, "ship7.spr") 
{
  data.shields = SHIP7_SHIELDS;
  data.hull = SHIP7_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP7L;
}

///////////////
void lPlayer7::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP7_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP7_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP7_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP7_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP7_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP7_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP7_SPEED)
    data.speed = -SHIP7_SPEED;
  if (data.speed > SHIP7_SPEED)
    data.speed = SHIP7_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer7::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new LaserCannon(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new MiniLaser(data.pos.x, data.pos.y, data.angle, this, data.team);
    new LaserCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new HomingMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer7::TakeDamage() {}

//===========================================================================
lPlayer8::lPlayer8(UnitData &info):
Unit(info, "ship8.spr") 
{
  data.shields = SHIP8_SHIELDS;
  data.hull = SHIP8_HULL;
  data.collision = data.hull;
  data.classname = C_SHIP8L;
}

///////////////
void lPlayer8::PreThink()
{
  ParticleData init;
           int angle;
  
  if (data.speed > 0)
    data.speed--;
  if (data.speed < 0)
    data.speed++;

  if (keyb.Pressed(kLEFT))
    if (!keyb.Pressed(kALT))
      data.angle -= SHIP8_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 270, SHIP8_SPEED);
      data.pos.y += yAdj(data.angle + 270, SHIP8_SPEED);
    }
  
  if (keyb.Pressed(kRIGHT))
    if (!keyb.Pressed(kALT))
      data.angle += SHIP8_TURNRATE;
    else
    {
      data.pos.x += xAdj(data.angle + 90, SHIP8_TURNRATE);
      data.pos.y += yAdj(data.angle + 90, SHIP8_TURNRATE);
    }
  
  if (keyb.Pressed(kUP))
    data.speed += 3;

  if (keyb.Pressed(kDOWN))
    data.speed -= 2;

  if (data.speed < -SHIP8_SPEED)
    data.speed = -SHIP8_SPEED;
  if (data.speed > SHIP8_SPEED)
    data.speed = SHIP8_SPEED;
  
  if (keyb.Pressed(kLEFTSHIFT) || keyb.Pressed(kRIGHTSHIFT))  
  {
    for(angle = 120; angle < 240; angle += 10)
    {
      init.pos.x = data.pos.x + xAdj(data.angle + angle, (rand() % 7));
      init.pos.y = data.pos.y + yAdj(data.angle + angle, (rand() % 7));
      init.pos.x += xAdj(data.angle + 180, rand() % 12);
      init.pos.y += yAdj(data.angle + 180, rand() % 12);
      init.color = 56 + (rand() % 8);
      init.angle = 0;
      init.speed = 0;
      init.life = 1 + (rand() % 2);
      init.decay = 0;
      part.Add(init);
    }
    data.speed += 10;
  }
  
  FixAngle(data.angle);
  data.drawangle = data.angle;

  world.SetLoc((data.pos.x + xAdj(data.angle, data.speed)) - 160, 
                (data.pos.y + yAdj(data.angle, data.speed)) - 100);
}

///////////////
void lPlayer8::PostThink()
{
  if (keyb.Pressed(kCTRL))
  {
    new PlasmaCannon(data.pos.x + xAdj(data.angle - 90, 8),
                    data.pos.y + yAdj(data.angle - 90, 8), data.angle, this, data.team);
    new PlasmaCannon(data.pos.x + xAdj(data.angle + 90, 8), 
                    data.pos.y + yAdj(data.angle + 90, 8), data.angle, this, data.team);
  }
  
  if (keyb.Pressed(kZ))
    new SmartMissile(data.pos.x, data.pos.y, data.angle, this, data.team);
}

///////////////
void lPlayer8::TakeDamage() {}

